#include <Servo.h> // we included the servo library

// we defined the pins to which our colour sensor will be connected 
#define S0 2 
#define S1 3
#define S2 4
#define S3 5
#define sensorOut 6



// we have defined the servo objects that we have used
Servo topServo; 
Servo bottomServo;

// we have declaired variables needed for the program
int frequency = 0; 
int color=0;

// we defined the pins as INPUTS and OUTPUTS
void setup() {
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);

// we have set the frequency scaling for the colour sensor
  digitalWrite(S0, HIGH);
  digitalWrite(S1, LOW);

// we have defined the servo pins
  topServo.attach(7);
  bottomServo.attach(8);

// started the sirial communication to print the results of the colour read
  Serial.begin(9600);
}






void loop() {

  topServo.write(125);  // we have defined the angle that the top servo needs to move util the skitle charger
  delay(3000);
 

  topServo.write(65);
  delay(2000);

  
  bottomServo.write(100);
  delay(1000);

  
// here is where the colour sensor starts working 
 color = detectColor();
  delay(3000);

  
//Depending Upon the color detected, the drop servo motor moves with particular angle and drops the color ball to its respective box.
 switch (color) {
    case 1:
    bottomServo.write(90);
    break;
    case 2:
    bottomServo.write(30);
    case 3:
    bottomServo.write(65);
    }
  delay(500);


  topServo.write(32); 
  delay(200); }


//colour read
int detectColor(){

//Writing to S2 and S3 (LOW,LOW) activates the red photodiodes 
 digitalWrite(S2, LOW);
 digitalWrite(S3, LOW);
 frequency = pulseIn(sensorOut, LOW);
 int R = frequency;
 Serial.print("Red = ");
 Serial.print(frequency);//printing RED color frequency
 Serial.print("   ");
 delay(50);

  
//Writing to S2 and S3 (LOW,HIGH) activates the blue photodiodes
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  frequency = pulseIn(sensorOut, LOW);
  int B = frequency;
  Serial.print("Blue = ");
  Serial.print(frequency);
  Serial.println("   ");



//Writing to S2 and S3 (HIGH,HIGH) activates the green photodiodes
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);

  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  int G = frequency;
  Serial.print("Green = ");
  Serial.print(frequency);
  Serial.print("   ");
  delay(50);

  

// values are compared to make the color decision
 
  if(G<517&G>480 & B<379&B>340 & R<607&R>557){
    color = 1; // Orange
      Serial.println("Orange  ");
  }
  if(G<465&G>445 & B<351&B>340 & R<676&R>563){
    color = 2; // Green
      Serial.print("Detected Color is = ");
    Serial.println("Green");
  }

  return color; 
}
